

const path = require('path');
// eslint-disable-next-line import/no-extraneous-dependencies
const CleanWebpackPlugin = require('clean-webpack-plugin');
const { version } = require('./package.json');
var webpack = require("webpack");

module.exports = [{
  // entry: ['babel-polyfill', './index.js'],
  entry: './umd.js',
  output: {
    path: path.join(__dirname, '/lib'),
    filename: 'index.js',
    library: 'WebChat',
    libraryTarget: 'umd'
  },
  resolve: {
    extensions: ['.js', '.jsx']
  },
  mode: 'production',
  module: {
    rules: [
      {
        test: /\.(js|jsx)$/,
        exclude: /node_modules/,
        use: [
          {
            loader: 'string-replace-loader',
            options: {
              search: 'PACKAGE_VERSION_TO_BE_REPLACED',
              replace: version
            }
          },
          { loader: 'babel-loader' }
        ]
      },
      {
        test: /\.scss$/,
        use: [
          { loader: 'style-loader' },
          { loader: 'css-loader' },
          {
            loader: 'sass-loader',
            options: {
              includePaths: [path.resolve(__dirname, 'src/scss/')]
            }
          }
        ]
      },
      {
        test: /\.css$/,
        use: ['style-loader', 'css-loader']
      },
      {
        test: /\.(jpg|png|gif|svg|woff|ttf|eot)$/,
        use: {
          loader: 'url-loader'
        }
      }
    ]
  },
  plugins: [new CleanWebpackPlugin(['lib']),
  new webpack.BannerPlugin("Copyright 2022 Sages, Licensed under the Apache License, Version 2.0 (the \"License\") \n" +
  "you may not use this file except in compliance with the License.\n"  +
  "You may obtain a copy of the License at\n"  +
    "\n" +
     " http://www.apache.org/licenses/LICENSE-2.0\n"  +
    "\n" +
  "Unless required by applicable law or agreed to in writing, software\n"  +
  "distributed under the License is distributed on an \"AS IS\" BASIS,\n"  +
  "WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"  +
  "See the License for the specific language governing permissions and\n" +
  "limitations under the License.")]
}, {
  entry: './index.js',
  externals: {
    react: {
      root: 'React',
      commonjs2: 'react',
      commonjs: 'react',
      amd: 'react',
      umd: 'react'
    },
    'react-dom': {
      root: 'ReactDOM',
      commonjs2: 'react-dom',
      commonjs: 'react-dom',
      amd: 'react-dom',
      umd: 'react-dom'
    }
  },
  output: {
    path: path.join(__dirname, '/module'),
    filename: 'index.js',
    library: 'WebChat',
    libraryTarget: 'umd'
  },
  resolve: {
    extensions: ['.js', '.jsx']
  },
  mode: 'production',
  module: {
    rules: [
      {
        test: /\.(js|jsx)$/,
        exclude: /node_modules/,
        use: [
          {
            loader: 'string-replace-loader',
            options: {
              search: 'PACKAGE_VERSION_TO_BE_REPLACED',
              replace: version
            }
          },
          { loader: 'babel-loader' }
        ]
      },
      {
        test: /\.scss$/,
        use: [
          { loader: 'style-loader' },
          { loader: 'css-loader' },
          {
            loader: 'sass-loader',
            options: {
              includePaths: [path.resolve(__dirname, 'src/scss/')]
            }
          }
        ]
      },
      {
        test: /\.css$/,
        use: ['style-loader', 'css-loader']
      },
      {
        test: /\.(jpg|png|gif|svg|woff|ttf|eot)$/,
        use: {
          loader: 'url-loader'
        }
      }
    ]
  },
  plugins: [
    new CleanWebpackPlugin(['module']),
    new webpack.BannerPlugin("Copyright 2022 Sages, Licensed under the Apache License, Version 2.0 (the \"License\") \n" +
    "you may not use this file except in compliance with the License.\n"  +
    "You may obtain a copy of the License at\n"  +
      "\n" +
       " http://www.apache.org/licenses/LICENSE-2.0\n"  +
      "\n" +
    "Unless required by applicable law or agreed to in writing, software\n"  +
    "distributed under the License is distributed on an \"AS IS\" BASIS,\n"  +
    "WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"  +
    "See the License for the specific language governing permissions and\n" +
    "limitations under the License.")
  ]
}
];
